---
title: Firefox 75 for developers
slug: Mozilla/Firefox/Releases/75
tags:
  - '75'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 75 that will affect developers. Firefox 75 was released on April 7, 2020.</p>

<p class="summary"><strong>See also the accompanying hacks post — <a href="https://hacks.mozilla.org/2020/04/firefox-75-ambitions-for-april/">Firefox 75: Ambitions for April</a>.</strong></p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>It is now possible to resize the rectangle of the <a href="/en-US/docs/Tools/Measure_a_portion_of_the_page">Measuring Tool</a> ({{bug(1152321)}}).</li>
 <li>In the <a href="/en-US/docs/Tools/Page_Inspector">inspector</a>, you can now use <a href="/en-US/docs/Web/XPath">XPath</a> expressions to locate elements, in addition to locating elements using CSS selectors as before ({{bug(963933)}}).</li>
 <li>You can now filter <a href="/en-US/docs/Web/API/WebSockets_API">WebSocket</a> messages using <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">regular expressions</a>, in addition to plain text search, by writing the regular expression in slashes ({{bug(1593837)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The {{htmlattrxref("loading", "img")}} attribute of the {{HTMLElement("img")}} element has now been implemented. This string value can be used to specify that the image should be <a href="/en-US/docs/Web/Performance/Lazy_loading">lazily loaded</a>, by setting its value to <code>lazy</code> ({{bug(1542784)}}).</li>
 <li>The value of the <code><a href="/en-US/docs/Web/HTML/Element/style">&lt;style&gt;</a></code> element's <code>type</code> attribute is now restricted to <code>text/css</code> only, as per the spec ({{bug(1614329)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Support for the {{cssxref("min")}}, {{cssxref("max")}}, and {{cssxref("clamp")}} functions has been implemented ({{bug(1519519)}}).</li>
 <li>The <code>all</code> value of the {{cssxref("text-decoration-skip-ink")}} property has been added ({{bug(1611965)}})</li>
</ul>

<h3 id="Accessibility">Accessibility</h3>

<p>The new roles and objects related to <a href="/en-US/docs/Web/Accessibility/ARIA/Annotations">ARIA annotations</a> are now exposed in Firefox, on Windows and Linux (bear in mind that these still won't be usable until screenreaders start to support them):</p>

<ul>
 <li><code>aria-description</code> ({{bug(1608961)}}).</li>
 <li><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Mark_role">role="mark"</a></code> and <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Suggestion_role">role="suggestion"</a></code> ({{bug(1608965)}}).</li>
 <li><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Comment_role">role="comment"</a></code> ({{bug(1608969)}}).</li>
 <li>Multiple IDs on <code>aria-details</code> ({{bug(1608883)}}).</li>
</ul>

<div class="notecard note">
<p><strong>Note</strong>: On macOS, we are first waiting for Apple to define what Safari will expose as Apple-dialect attributes to VoiceOver, and will then follow suit.</p>
</div>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Classes/Class_fields#Public_static_fields">Public static class fields</a> are now supported ({{bug(1535804)}}).</li>
 <li>The <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Locale">Intl.Locale</a></code> class is now supported ({{bug(1613713)}}).</li>
 <li>The <a href="https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Function/caller"><code>Function.caller</code></a> property has been updated to be aligned with the latest <a href="https://github.com/claudepache/es-legacy-function-reflection">ECMAScript spec proposal</a>. Previously throwing a <code>TypeError</code>, it now returns <code>null</code> if the caller is a strict, async, or generator function ({{bug(1610206)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The {{domxref("HTMLFormElement")}} interface has a new method, {{domxref("HTMLFormElement.requestSubmit", "requestSubmit()")}}. Unlike the old (and still available) {{domxref("HTMLFormElement.submit", "submit()")}} method, <code>requestSubmit()</code> acts as if a specified submit button has been clicked, rather than just sending the form data to the recipient. Thus the {{domxref("HTMLFormElement.submit_event", "submit")}} event is delivered and the form is checked for validity prior to the data being submitted ({{bug(1613360)}}).</li>
 <li>The {{domxref("HTMLFormElement.submit_event", "submit")}} event is now represented by an object of type {{domxref("SubmitEvent")}} rather than a simple {{domxref("Event")}}. <code>SubmitEvent</code> includes a new {{domxref("SubmitEvent.submitter", "submitter")}} property, which is the {{domxref("Element")}} that was invoked to trigger the form submission. With this event, you can have a single handler for submit events that can discern which of multiple submit buttons or links was used to submit the form ({{bug(1588715)}}).</li>
 <li>Calling the {{domxref("HTMLElement.click", "click()")}} method on a detached element (one not part of a DOM tree) now functions normally, leading to a <code>click</code> event being sent to it ({{bug(1610821)}}).</li>
</ul>

<h4 id="Web_animations_API">Web animations API</h4>

<p>Firefox 75 sees numerous additions to the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a>:</p>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API/Keyframe_Formats#Implicit_tofrom_keyframes">Implicit to/from keyframes</a> are now supported, as is automatically removing filling animations that have been replaced by other indefinitely filling animations ({{bug(1618773)}}). This includes enabling of support for:

  <ul>
   <li><code><a href="/en-US/docs/Web/API/Animation/commitStyles">Animation.commitStyles()</a></code></li>
   <li><code><a href="/en-US/docs/Web/API/Animation/onremove">Animation.onremove</a></code></li>
   <li><code><a href="/en-US/docs/Web/API/Animation/persist">Animation.persist()</a></code></li>
   <li><code><a href="/en-US/docs/Web/API/Animation/replaceState">Animation.replaceState</a></code></li>
  </ul>
 </li>
 <li>The <code><a href="/en-US/docs/Web/API/Animation/timeline">Animation.timeline</a></code> getter, <code><a href="/en-US/docs/Web/API/Document/timeline">Document.timeline</a></code>, <code><a href="/en-US/docs/Web/API/DocumentTimeline">DocumentTimeline</a></code>, and <code><a href="/en-US/docs/Web/API/AnimationTimeline">AnimationTimeline</a></code> features are now enabled by default ({{bug(1619178)}}).</li>
 <li>The <code><a href="/en-US/docs/Web/API/Document/getAnimations">Document.getAnimations()</a></code> and <code><a href="/en-US/docs/Web/API/Element/getAnimations">Element.getAnimations()</a></code> methods are now enabled by default ({{bug(1619821)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The <code><a href="/en-US/docs/Web/API/RTCPeerConnection/setLocalDescription">RTCPeerConnection.setLocalDescription()</a></code> method can now be called without arguments, in which case the WebRTC runtime will try to create the new local session description itself ({{bug(1568292)}}).</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<p><em>No changes.</em></p>

<h3 id="Security">Security</h3>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/CSP">CSP</a> nonces from non-script sources, such as CSS selectors, and  <code>.getAttribute("nonce")</code> calls, are now hidden. Instead, check the <code><a href="/en-US/docs/Web/API/HTMLOrForeignElement/nonce">.nonce</a></code> property to access nonces from scripts ({{bug(1374612)}}).</li>
</ul>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="Security_2">Security</h3>

<p><em>No changes.</em></p>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<ul>
 <li>Fixed a bug that always caused Marionette to initialize when Firefox starts-up. It has been limited to the command line argument and environment variable now ({{bug(1622012)}}).</li>
 <li>Fixed <code>WebDriver:Print</code> to no longer add extra margins to the document ({{bug(1616932)}}).</li>
 <li class="sourcelines">Changed the preference <span class="difflineminus" id="l1.14">value for </span><code><span class="difflineminus">network.http.speculative-parallel-limit</span></code><span class="difflineminus"> to <code>0</code>, to no longer force-disable speculative connections </span>({{bug(1617869)}}).</li>
</ul>

<h3 id="Other">Other</h3>

<p><em>No changes.</em></p>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes">API changes</h3>

<ul>
 <li>We've added some new settings in {{WebExtAPIRef("browserSettings")}} ({{bug(1286953)}}):
  <ul>
   <li>{{WebExtAPIRef("browserSettings.zoomSiteSpecific")}} to control whether zooming is on a per-site or per-tab basis</li>
   <li>{{WebExtAPIRef("browserSettings.zoomFullPage")}} to control whether zoom is applied to the entire page or to text only.</li>
  </ul>
 </li>
 <li>The name of the file used when saving a PDF with {{WebExtAPIRef("tabs.saveAsPDF")}} can be specified using <code>toFileName</code> in the type <code>tabs.PageSettings</code>.({{bug(1483590)}})</li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<ul>
 <li> The "privacy" permission is now optional. ({{bug(1618399)}})</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/75/">Site compatibility for Firefox 75</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(74)}}</p>
